package be.iminds.ilabt.jfed.experiment.setup.config;

import com.fasterxml.jackson.annotation.*;

import javax.annotation.Nullable;

@JsonInclude(JsonInclude.Include.NON_DEFAULT)
@JsonIgnoreProperties(value={"@context"})
public class Provision {
    //Allocate, Provision, POA    (skipped if requestRspec method is "already_povisioned")
//        private final long provisionExpireTimeMin;
    private final boolean useGeniEndTimeOptionForCreateSliver;
    private final boolean enabled;
    @Nullable private final String scs; //URL or ID of service (int as string)

    public Provision() {
//            this.provisionExpireTimeMin = 25;
        this.useGeniEndTimeOptionForCreateSliver = false;
        this.enabled = true;
        this.scs = null;
    }
    @JsonCreator
    public Provision(
//                @Nullable @JsonProperty("provisionExpireTimeMin") Long provisionExpireTimeMin,
            @Nullable @JsonProperty("useGeniEndTimeOptionForCreateSliver") Boolean useGeniEndTimeOptionForCreateSliver,
            @Nullable @JsonProperty("enabled") Boolean enabled,
            @Nullable @JsonProperty("scs") String scs
    ) {
//            this.provisionExpireTimeMin = provisionExpireTimeMin == null ? new Provision().getProvisionExpireTimeMin() : provisionExpireTimeMin;
        this.useGeniEndTimeOptionForCreateSliver = useGeniEndTimeOptionForCreateSliver == null ? new Provision().getUseGeniEndTimeOptionForCreateSliver() : useGeniEndTimeOptionForCreateSliver;
        this.enabled = enabled == null ? new Provision().isEnabled() : enabled;
        this.scs = scs == null ? new Provision().getScs() : scs;
    }

    @JsonIgnore
    public boolean isValid() {
        return true;
    }

//        @JsonProperty
//        public long getProvisionExpireTimeMin() {
//            return provisionExpireTimeMin;
//        }

    @JsonProperty
    public boolean getUseGeniEndTimeOptionForCreateSliver() {
        return useGeniEndTimeOptionForCreateSliver;
    }

    @JsonProperty
    public boolean isEnabled() {
        return enabled;
    }

    @Nullable
    public String getScs() {
        return scs;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Provision)) return false;

        Provision provision = (Provision) o;

        if (useGeniEndTimeOptionForCreateSliver != provision.useGeniEndTimeOptionForCreateSliver) return false;
        return enabled == provision.enabled;
    }

    @Override
    public int hashCode() {
        int result = (useGeniEndTimeOptionForCreateSliver ? 1 : 0);
        result = 31 * result + (enabled ? 1 : 0);
        return result;
    }
}
